/*------------------------------------------------------------------------
 |  FILE            TCPGameClient.java
 |  PART OF         SHH SpaceGame - a simple, networked multiplayer game.
 |  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 +----------------------------------------------------------------------*/

package netgame;

import java.io.*;
import java.net.*;

/**
 *
 * @author    Sverre H. Huseby
 *            &lt;<a href="mailto:shh@thathost.com">shh@thathost.com</a>&gt;
 * @version   $Id: TCPGameClient.java,v 1.6 2002/10/13 20:36:22 sverrehu Exp $
 */
public abstract class TCPGameClient
extends TCPCommunicator
implements Runnable {
/*-----------------------------------------------------------------------+
 |  PRIVATE PART                                                         |
 +----------------------------------------------------------------------*/
    Thread thread;
    private boolean done;

/*-----------------------------------------------------------------------+
 |  INHERITANTS' INTERFACE                                               |
 +----------------------------------------------------------------------*/
    protected String host;
    protected int port;

    protected abstract boolean readIncoming();

/*-----------------------------------------------------------------------+
 |  PUBLIC INTERFACE                                                     |
 +----------------------------------------------------------------------*/
    public TCPGameClient(String host, int port)
    throws IOException {
        this.host = host;
        this.port = port;

        done = false;
        thread = new Thread(this);

        setupSocketToUse(new Socket(host, port));
    }

    public void start() {
        thread.start();
    }

    public void stop() {
        done = true;
        thread.interrupt();
    }

    /* Runnable *********************************************************/
    public void run() {
        if (!isConnected())
            return;

        while (!done && readIncoming())
            ;
        close();
    }
}
