/*------------------------------------------------------------------------
 |  FILE            UpdatingExplosion.java
 |  PART OF         SHH SpaceGame - a simple, networked multiplayer game.
 |  WRITTEN BY      Sverre H. Huseby <shh@thathost.com>
 +----------------------------------------------------------------------*/

package server;

import java.awt.*;

import objects.*;

/**
 *
 * @author    Sverre H. Huseby
 *            &lt;<A HREF="mailto:shh@thathost.com">shh@thathost.com</A>&gt;
 * @version   $Id: UpdatingExplosion.java,v 1.3 2002/01/27 14:47:33 sverrehu Exp $
 */
final class UpdatingExplosion
extends Explosion {
/*-----------------------------------------------------------------------+
 |  PRIVATE PART                                                         |
 +----------------------------------------------------------------------*/
    private static short nextId = 0;

    private Server  server;
    private World   world;
    private boolean remove;

/*-----------------------------------------------------------------------+
 |  PACKAGE LOCAL PART                                                   |
 +----------------------------------------------------------------------*/
    static final short getNextId() {
        return nextId++;
    }

    /* called by the updater daemon */
    final synchronized boolean update() {
        setLevel((byte) (getLevel() + 1));
        if (getLevel() > getMaxLevel())
            remove = true;
        return true;
    }

    final boolean doRemove() {
        return remove;
    }

/*-----------------------------------------------------------------------+
 |  PUBLIC INTERFACE                                                     |
 +----------------------------------------------------------------------*/
    public UpdatingExplosion(Server server, World world, short id,
                             int x, int y, byte level, byte maxLevel) {
        super(id, x, y, level, maxLevel);

        this.server = server;
        this.world = world;
        remove = false;
    }
}
